Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/694.html

694. Number of Distinct Islands (Medium)

Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.

Count the number of distinct islands. An island is considered to be the same as another if and only if one island can be translated (and not rotated or reflected) to equal the other.

Example 1:

11000
11000
00011
00011

Given the above grid map, return 1.

Example 2:

11011
10000
00001
11011

Given the above grid map, return 3.

Notice that:

11
1

and

 1
11

are considered different island shapes, because we do not consider reflection / rotation.

Note: The length of each dimension in the given grid does not exceed 50.

Companies:
Amazon, Google, Facebook, Microsoft, Lyft

Related Topics:
Hash Table, Depth-first Search

Similar Questions:

Solution 1. Encode Shape

// OJ: https://leetcode.com/problems/number-of-distinct-islands/
// Time: O(MN)
// Space: O(MN)
// Ref: https://leetcode.com/problems/number-of-distinct-islands/discuss/194673/C%2B%2B-easy-to-understand
class Solution {
private:
    unordered_set<string> s;
    int M, N;
    void explore(vector<vector<int>>& grid, int x, int y, string &path, char dir) {
        if (x < 0 || x >= M || y < 0 || y >= N || !grid[x][y]) return;
        grid[x][y] = 0;
        path.push_back(dir);
        explore(grid, x + 1, y, path, 'd');
        explore(grid, x, y + 1, path, 'r');
        explore(grid, x - 1, y, path, 'u');
        explore(grid, x, y - 1, path, 'l');
        path.push_back('x');
    }
public:
    int numDistinctIslands(vector<vector<int>>& grid) {
        M = grid.size();
        N = grid[0].size();
        for (int i = 0; i < M; ++i) {
            for (int j = 0; j < N; ++j) {
                string path;
                explore(grid, i, j, path, 'o');
                if (path.size()) s.insert(path);
            }
        }
        return s.size();
    }
};
  • class Solution {
        final int WATER = -1;
    	final int WHITE = 0;
    	final int GRAY = 1;
    	final int BLACK = 2;
    	int[][] directions = { {-1, 0}, {1, 0}, {0, -1}, {0, 1} };
    
    	public int numDistinctIslands(int[][] grid) {
    		int rows = grid.length, columns = grid[0].length;
    		int[][] colors = new int[rows][columns];
    		for (int i = 0; i < rows; i++) {
    			for (int j = 0; j < columns; j++) {
    				if (grid[i][j] == 0)
    					colors[i][j] = WATER;
    			}
    		}
    		Set<String> set = new HashSet<String>();
    		for (int i = 0; i < rows; i++) {
    			for (int j = 0; j < columns; j++) {
    				if (colors[i][j] == WHITE) {
    					int[] position = {i, j};
    					String shape = breadthFirstSearch(colors, position);
    					set.add(shape);
    				}
    			}
    		}
            return set.size();
        }
    
    	public String breadthFirstSearch(int[][] colors, int[] position) {
    		List<String> shapeList = new ArrayList<String>();
    		int rows = colors.length, columns = colors[0].length;
    		int startRow = position[0], startColumn = position[1];
    		Queue<int[]> queue = new LinkedList<int[]>();
    		colors[startRow][startColumn] = GRAY;
    		queue.offer(position);
    		while (!queue.isEmpty()) {
    			int[] curPosition = queue.poll();
    			int curRow = curPosition[0], curColumn = curPosition[1];
    			int[] relativePosition = {curRow - startRow, curColumn - startColumn};
    			shapeList.add(Arrays.toString(relativePosition));
    			for (int[] direction : directions) {
    				int newRow = curRow + direction[0], newColumn = curColumn + direction[1];
    				if (newRow >= 0 && newRow < rows && newColumn >= 0 && newColumn < columns && colors[newRow][newColumn] == WHITE) {
    					int[] newPosition = {newRow, newColumn};
    					colors[newRow][newColumn] = GRAY;
    					queue.offer(newPosition);
    				}
    			}
    			colors[curRow][curColumn] = BLACK;
    		}
    		return shapeList.toString();
    	}
    }
    
    ############
    
    class Solution {
        private int m;
        private int n;
        private int[][] grid;
    
        public int numDistinctIslands(int[][] grid) {
            m = grid.length;
            n = grid[0].length;
            this.grid = grid;
            Set<String> paths = new HashSet<>();
    
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (grid[i][j] == 1) {
                        StringBuilder path = new StringBuilder();
                        dfs(i, j, 0, path);
                        paths.add(path.toString());
                    }
                }
            }
            return paths.size();
        }
    
        private void dfs(int i, int j, int direction, StringBuilder path) {
            grid[i][j] = 0;
            path.append(direction);
            int[] dirs = {-1, 0, 1, 0, -1};
            for (int k = 1; k < 5; ++k) {
                int x = i + dirs[k - 1];
                int y = j + dirs[k];
                if (x >= 0 && x < m && y >= 0 && y < n && grid[x][y] == 1) {
                    dfs(x, y, k, path);
                }
            }
            path.append(direction);
        }
    }
    
  • // OJ: https://leetcode.com/problems/number-of-distinct-islands/
    // Time: O(MN)
    // Space: O(MN)
    // Ref: https://leetcode.com/problems/number-of-distinct-islands/discuss/194673/C%2B%2B-easy-to-understand
    class Solution {
    private:
        unordered_set<string> s;
        int M, N;
        void explore(vector<vector<int>>& grid, int x, int y, string &path, char dir) {
            if (x < 0 || x >= M || y < 0 || y >= N || !grid[x][y]) return;
            grid[x][y] = 0;
            path.push_back(dir);
            explore(grid, x + 1, y, path, 'd');
            explore(grid, x, y + 1, path, 'r');
            explore(grid, x - 1, y, path, 'u');
            explore(grid, x, y - 1, path, 'l');
            path.push_back('x');
        }
    public:
        int numDistinctIslands(vector<vector<int>>& grid) {
            M = grid.size();
            N = grid[0].size();
            for (int i = 0; i < M; ++i) {
                for (int j = 0; j < N; ++j) {
                    string path;
                    explore(grid, i, j, path, 'o');
                    if (path.size()) s.insert(path);
                }
            }
            return s.size();
        }
    };
    
  • class Solution:
        def numDistinctIslands(self, grid: List[List[int]]) -> int:
            def dfs(i, j, direction, path):
                grid[i][j] = 0
                path.append(str(direction))
                dirs = [-1, 0, 1, 0, -1]
                for k in range(1, 5):
                    x, y = i + dirs[k - 1], j + dirs[k]
                    if 0 <= x < m and 0 <= y < n and grid[x][y] == 1:
                        dfs(x, y, k, path)
                path.append(str(-direction))
    
            paths = set()
            path = []
            m, n = len(grid), len(grid[0])
            for i in range(m):
                for j in range(n):
                    if grid[i][j] == 1:
                        dfs(i, j, 0, path)
                        paths.add(''.join(path))
                        path.clear()
            return len(paths)
    
    
    
  • func numDistinctIslands(grid [][]int) int {
    	m, n := len(grid), len(grid[0])
    	paths := make(map[string]bool)
    	path := ""
    	var dfs func(i, j, direction int)
    	dfs = func(i, j, direction int) {
    		grid[i][j] = 0
    		path += strconv.Itoa(direction)
    		dirs := []int{-1, 0, 1, 0, -1}
    		for k := 1; k < 5; k++ {
    			x, y := i+dirs[k-1], j+dirs[k]
    			if x >= 0 && x < m && y >= 0 && y < n && grid[x][y] == 1 {
    				dfs(x, y, k)
    			}
    		}
    		path += strconv.Itoa(direction)
    	}
    	for i := 0; i < m; i++ {
    		for j := 0; j < n; j++ {
    			if grid[i][j] == 1 {
    				path = ""
    				dfs(i, j, 0)
    				paths[path] = true
    			}
    		}
    	}
    	return len(paths)
    }
    

All Problems

All Solutions